function model = ivmOptimise(model, options);

% IVMOPTIMISE Optimise the IVM.
%
% model = ivmOptimise(model, options);
%

% Copyright (c) 2005 Neil D. Lawrence
% ivmOptimise.m version 1.9



% Run IVM
for i = 1:options.extIters
  if options.kernIters
    % Update the kernel if required.
    model = ivmOptimiseIVM(model, options.display);
    model = ivmOptimiseKernel(model, options.display, options.kernIters);
  end
  if options.noiseIters
    % Update the noise model if required.
    model = ivmOptimiseIVM(model, options.display);
    model = ivmOptimiseNoise(model, options.display, options.noiseIters);
  end
  ivmDisplay(model);
end
